import { ObjectState } from './object-state';
import StateValues from './state-values';
import { IBuildable, ICleanable, IResetable, ObjectValues } from './types';
export declare class CollectionState<T> implements ICleanable, IResetable, IBuildable<T[]> {
    private _elements;
    constructor(elements: T[]);
    get elements(): ObjectState<T>[];
    get dirtyElements(): ObjectState<T>[];
    get count(): number;
    get values(): (StateValues<T> & ObjectValues<T>)[];
    get(index: 0): ObjectState<T>;
    add(element: T): void;
    clean(): void;
    reset(): void;
    build(): T[];
    filter(fn: (element: StateValues<T> & ObjectValues<T>) => boolean): ObjectState<T>[];
    find(fn: (element: StateValues<T> & ObjectValues<T>) => boolean): ObjectState<T> | undefined;
    some(fn: (element: StateValues<T> & ObjectValues<T>) => boolean): boolean;
}
